#include <bits/stdc++.h>

using namespace std;

typedef unsigned int LL;

#ifdef _DEBUG
# define LOG(x...) fprintf(stderr, x)
#else
# define LOG(x...) 0
#endif

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
	cin.sync_with_stdio(0);

	int n, m;
	cin >> n >> m;

	struct Person {
		LL time;
		int floor;
		int id;
		
		bool operator<(const Person &o) const {
			return time != o.time ? time < o.time : id < o.id;
		}
	};
	
	vector<Person> a(n);
	
	for (int i = 0; i < n; ++i) {
		cin >> a[i].time >> a[i].floor;
		a[i].id = i;
	}
	
	unordered_map<int, int> conv;
	vector<int> deconv;
	deconv.reserve(n);
	
	{
		vector<int> xs;
		xs.reserve(n);
		for (auto p : a)
			xs.push_back(p.floor);
		
		sort(xs.begin(), xs.end());
		
		int prev = 1, cnt = 0;
		conv[prev] = cnt++;
		deconv.push_back(prev);
		
		for (auto x : xs) {
			if (x != prev) {
				deconv.push_back(x);
				conv[x] = cnt++;
				prev = x;
			}
		}
	}
	
	sort(a.begin(), a.end());
	
	for (int i = 0; i < n; ++i)
		a[i].floor = conv[a[i].floor];
	
	int itdone = 0, itcome = 0; // itcome >= itdone
	
	vector<vector<int>> q(conv.size());
	vector<LL> ans(n, 0);
	
	int targetf = 0, curf = 0;
	bool active = 0, down = 0;
	LL timer = 0;
	
	vector<int> inside;
	inside.reserve(n);
	
	while (itdone != n) {
		while (itdone < n && ans[a[itdone].id] != 0) itdone++;
		while (itcome < n && a[itcome].time <= timer) {
			q[a[itcome].floor].push_back(a[itcome].id);
			itcome++;
		}
		if (itdone == n) break;
		
		if (active) {
			if (down) {
				if (curf == 0) {
					down = 0;
					active = 0;
					for (auto x : inside) {
						ans[x] = timer;
					}
					inside.clear();
				}
				else {
					if (q[curf].size()) {
						inside.insert(inside.end(), q[curf].begin(), q[curf].end());
						q[curf].clear();
					}
					
					LL delta = deconv[curf] - deconv[curf - 1];
					
					timer += delta;
					curf--;
				}
			} else {
				if (curf < targetf) {
					LL delta = deconv[curf + 1] - deconv[curf];
					timer += delta;
					curf++;
				}
				else if (curf == targetf) {
					down = 1;
				}
			}
		} else {
			if (itcome == itdone) {
				timer = a[itcome].time;		
			} else {
				active = 1;
				down = 0;
				targetf = a[itdone].floor;
			}
		}
	}
	
	for (int i = 0; i < n; ++i)
		cout << ans[i] << '\n';
	
	return 0;
}