#include <bits/stdc++.h>

using namespace std;

typedef long long LL;

const LL INF = (LL)1e14;

#ifdef _DEBUG
# define LOG(x...) fprintf(stderr, x)
#else
# define LOG(x...) 0
#endif

vector<vector<int>*> g;

struct Riba {
	char c;
	int p;
	int depth;
	bool leaf;
	long long w;
	int suf;
	
	int next[26];
	int go[26];
};

const int ribaroot = 0;

vector<Riba> ribka;

void build(long long w, const string &s, int v) {
	for (auto c : s) {
		if (ribka[v].next[c - 'a'] != -1) {
			v = ribka[v].next[c - 'a'];
		} else {
			int id = ribka.size();
			
			ribka.push_back(Riba{c, v, ribka[v].depth + 1, 0, INF, -1});
			for (int i = 0; i < 26; ++i)
				ribka[id].next[i] =  ribka[id].go[i] = -1;
			
			ribka[v].next[c - 'a'] = id;
			v = id;
		}
	}
	
	if (!ribka[v].leaf) {
		ribka[v].leaf = 1;
		ribka[v].w = w;
	} else {
		ribka[v].w = min(ribka[v].w, w);
	}
}

int getsuf(int v);

int go(int v, char c) {
	if (ribka[v].go[c - 'a'] != -1)
		return ribka[v].go[c - 'a'];
	if (ribka[v].next[c - 'a'] != -1)
		return ribka[v].go[c - 'a'] = ribka[v].next[c - 'a'];
	if (v == ribaroot)
		return ribka[v].go[c - 'a'] = ribaroot;
	return ribka[v].go[c - 'a'] = go(getsuf(v), c);
}

int getsuf(int v) {
	if (ribka[v].suf != -1) return ribka[v].suf;
	if (ribka[v].p == 0 || ribka[v].p == -1)
		return ribka[v].suf = 0;
	return ribka[v].suf = go(getsuf(ribka[v].p), ribka[v].c);
}


vector<int> path;
vector<vector<LL>> up;
void dfsinit(int v, int rv) {
	LOG("dfsinit %d %d\n", v, rv);
	path.push_back(v);
	
	int tmp = rv;
	while (tmp != 0) {
		LOG("suf %d\n", tmp);
		if (ribka[tmp].leaf) {
			up[v][path[path.size() - ribka[tmp].depth - 1]] = ribka[tmp].w;
		}
		tmp = getsuf(tmp);
	}
	
	for (char c = 'a'; c <= 'z'; ++c) {
		int rto = go(rv, c);
		for (auto to : g[v][(int)(c - 'a')]) {
			LOG("call dfsinit %d %d\n", to, rto);
			dfsinit(to, rto);
		}
	}
	
	path.pop_back();
}

vector<LL> calced;

vector<LL> dfscalc(int v) {
	path.push_back(v);
	vector<vector<LL>> sons;
	for (char c = 'a'; c <= 'z'; ++c) {
		for (auto to : g[v][(int)(c - 'a')]) {
			sons.push_back(dfscalc(to));
		}
	}
	
	vector<LL> mns(sons.size());
	for (int i = 0; i < (int)sons.size(); ++i) {
		mns[i] = sons[i][v];
		calced[v] += sons[i][v];
	}
	
	calced[v] = min(calced[v], INF);
	
	int depth = (int)path.size() - 2;
	
	vector<LL> res(calced.size(), INF);
	
	while (depth >= 0) {
		LL sum = 0;
		for (int i = 0; i < (int)sons.size(); ++i) {
			mns[i] = min(mns[i], sons[i][path[depth]]);
			sum += mns[i];
		}
		
		LL dp = INF;
		
		dp = min(dp, sum + up[v][path[depth]]);
		
		for (int i = 0; i < (int)sons.size(); ++i) {
			dp = min(dp, sum - mns[i] + sons[i][path[depth]]);
		}
		
		res[path[depth]] = dp;
		
		depth--;
	}
	
	path.pop_back();
	return res;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
	cin.sync_with_stdio(0);
	
	int n, m, t;
	cin >> n >> m >> t;
	
	g.resize(n + 1);
	
	for (int i = 0; i < n + 1; ++i)
		g[i] = new vector<int>[26];
	
	for (int i = 2; i <= n; ++i) {
		int p;
		char c;
		cin >> p >> c;
		g[p][c - 'a'].push_back(i);
	}
	
	ribka.push_back(Riba{'-', -1, 0, 0, INF, 0});
	for (int i = 0; i < 26; ++i)
		ribka[0].next[i] =  ribka[0].go[i] = -1;
	
	for (int i = 0; i < m; ++i) {
		long long w;
		string s;
		cin >> w >> s;
		
		build(w, s, ribaroot);
	}

	up.resize(n + 1, vector<LL>(n + 1, INF));
	dfsinit(1, 0);
	
	calced.resize(n + 1);
	dfscalc(1);
	
	if (calced[1] == -1)
		cout << -1 << '\n';
	else 
		cout << calced[1] << '\n';
	
#ifdef _DEBUG
	for (auto r : ribka) {
		LOG("ribka: c=%c p=%d w=%I64d suf=%d\n", r.c, r.p, r.w, r.suf);
	}
	
	for (int i = 1; i <= n; ++i) {
		for (int to = 1; to <= n; ++to) {
			if (up[i][to] != INF)
				LOG("%d -> %d  =%I64d\n", i, to, up[i][to]);
		}
	}
#endif
	return 0;
}