#include <bits/stdc++.h>

using namespace std;

typedef long long LL;

const LL INF = (LL)1e14;

#ifdef _DEBUG
# define LOG(x...) fprintf(stderr, x)
#else
# define LOG(x...) 0
#endif

vector<vector<int>*> g;

struct Riba {
	char c;
	int p;
	int depth;
	bool leaf;
	long long w;
	int wid;
	int suf;
	
	int next[26];
	int go[26];
};

const int ribaroot = 0;

vector<Riba> ribka;

void build(long long w, int wid, const string &s, int v) {
	for (auto c : s) {
		if (ribka[v].next[c - 'a'] != -1) {
			v = ribka[v].next[c - 'a'];
		} else {
			int id = ribka.size();
			
			ribka.push_back(Riba{c, v, ribka[v].depth + 1, 0, INF, 0, -1});
			for (int i = 0; i < 26; ++i)
				ribka[id].next[i] =  ribka[id].go[i] = -1;
			
			ribka[v].next[c - 'a'] = id;
			v = id;
		}
	}
	
	if (!ribka[v].leaf) {
		ribka[v].leaf = 1;
		ribka[v].w = w;
		ribka[v].wid = wid;
	} else {
		if (ribka[v].w > w) {
			ribka[v].w = w;
			ribka[v].wid = wid;
		}
	}
}

int getsuf(int v);

int go(int v, char c) {
	if (ribka[v].go[c - 'a'] != -1)
		return ribka[v].go[c - 'a'];
	if (ribka[v].next[c - 'a'] != -1)
		return ribka[v].go[c - 'a'] = ribka[v].next[c - 'a'];
	if (v == ribaroot)
		return ribka[v].go[c - 'a'] = ribaroot;
	return ribka[v].go[c - 'a'] = go(getsuf(v), c);
}

int getsuf(int v) {
	if (ribka[v].suf != -1) return ribka[v].suf;
	if (ribka[v].p == 0 || ribka[v].p == -1)
		return ribka[v].suf = 0;
	return ribka[v].suf = go(getsuf(ribka[v].p), ribka[v].c);
}

struct Used {
	LL cost;
	int wid;
	int par, v;
};

bool operator<(const pair<LL, vector<Used>> &a, const pair<LL, vector<Used>> &b) {
	return a.first < b.first;
}
bool operator<(const Used &a, const Used &b) {
	return a.cost < b.cost;
}

vector<int> path;
vector<vector<Used>> up;

void dfsinit(int v, int rv) {
	LOG("dfsinit %d %d\n", v, rv);
	path.push_back(v);
	
	int tmp = rv;
	while (tmp != 0) {
		LOG("suf %d\n", tmp);
		if (ribka[tmp].leaf) {
			auto &u = up[v][path[path.size() - ribka[tmp].depth - 1]];
			u.cost = ribka[tmp].w;
			u.wid = ribka[tmp].wid;
			u.par = path[path.size() - ribka[tmp].depth - 1];
			u.v = v;
		}
		tmp = getsuf(tmp);
	}
	
	for (char c = 'a'; c <= 'z'; ++c) {
		int rto = go(rv, c);
		for (auto to : g[v][(int)(c - 'a')]) {
			LOG("call dfsinit %d %d\n", to, rto);
			dfsinit(to, rto);
		}
	}
	
	path.pop_back();
}

vector<LL> calced;

vector<vector<Used>> pc;

vector<pair<LL, vector<Used>>> dfscalc(int v) {
	path.push_back(v);
	vector<vector<pair<LL, vector<Used>>>> sons;
	for (char c = 'a'; c <= 'z'; ++c) {
		for (auto to : g[v][(int)(c - 'a')]) {
			sons.push_back(dfscalc(to));
		}
	}
	
	LOG("\ncalc %d\n", v);
	
	vector<pair<LL, vector<Used>>> mns(sons.size(), pair<LL, vector<Used>>{INF, vector<Used>()}), mnsg(sons.size(), pair<LL, vector<Used>>{INF, vector<Used>()});
	Used upmin = up[v][path[0]];
	
	for (int i = 0; i < (int)sons.size(); ++i) {
		calced[v] += sons[i][v].first;
		pc[v].insert(pc[v].end(), sons[i][v].second.begin(), sons[i][v].second.end());
		
		for (auto x : path)
			mnsg[i] = min(mnsg[i], sons[i][x]);
	}
	
	calced[v] = min(calced[v], INF);
	
	vector<pair<LL, vector<Used>>> res(calced.size(), pair<LL, vector<Used>>{INF, vector<Used>()});
	
	for (int depth = 0; depth < (int)path.size() - 1; ++depth) {
		LL sum = 0;
		for (int i = 0; i < (int)sons.size(); ++i) {
			mns[i] = min(mns[i], sons[i][path[depth]]);
			sum += mnsg[i].first;
		}
		upmin = min(upmin, up[v][path[depth]]);
		
		LL dp = INF;
		vector<Used> pdp;
		
		if (sum + upmin.cost < dp) {
			dp = sum + upmin.cost;
			pdp.clear();
			pdp.push_back(upmin);
			for (auto x : mnsg) {
				pdp.insert(pdp.end(), x.second.begin(), x.second.end());
			}
		}
		
		int j = -1;
		for (int i = 0; i < (int)sons.size(); ++i) {
			if (dp > sum - mnsg[i].first + mns[i].first) {
				j = i;
				dp = sum - mnsg[i].first + mns[i].first;
			}
		}
		
		if (j != -1) {
			pdp.clear();
			for (int i = 0; i < (int)sons.size(); ++i) {
				if (i == j)
					pdp.insert(pdp.end(), mns[i].second.begin(), mns[i].second.end());
				else
					pdp.insert(pdp.end(), mnsg[i].second.begin(), mnsg[i].second.end());
			}
		}
		
		res[path[depth]] = {dp, pdp};
	}
	
	path.pop_back();
	return res;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
	cin.sync_with_stdio(0);
	
	int n, m, t;
	cin >> n >> m >> t;
	
	g.resize(n + 1);
	
	for (int i = 0; i < n + 1; ++i)
		g[i] = new vector<int>[26];
	
	for (int i = 2; i <= n; ++i) {
		int p;
		char c;
		cin >> p >> c;
		g[p][c - 'a'].push_back(i);
	}
	
	ribka.push_back(Riba{'-', -1, 0, 0, INF, 0, 0});
	for (int i = 0; i < 26; ++i)
		ribka[0].next[i] =  ribka[0].go[i] = -1;
	
	for (int i = 0; i < m; ++i) {
		long long w;
		string s;
		cin >> w >> s;
		
		build(w, i + 1, s, ribaroot);
	}

	up.resize(n + 1, vector<Used>(n + 1, Used{INF, 0, 0, 0}));
	dfsinit(1, 0);
	
	calced.resize(n + 1);
	pc.resize(n + 1);
	
	dfscalc(1);
	
	if (calced[1] == INF)
		cout << -1 << '\n';
	else {
		cout << calced[1] << '\n';
		if (t == 1) {
			cout << pc[1].size() << '\n';
			for (auto p : pc[1]) {
				cout << p.par << ' ' << p.v << ' ' << p.wid << '\n';
			}
		}
	}
	return 0;
}